<template>
  <div class="helper">
    <div class="helper__container">
      <div class="line breadcrumb">
        <breadcrumb
          class="_white"
          :breadcrumbs="breadcrumbs"/>
      </div>

      <div
        v-if="!complete"
        class="helper__request">
        <h1 class="helper__title">Автоконсьерж GisAuto сделает всё за&nbsp;вас&nbsp;бесплатно</h1>
        <div class="helper__abilities">
          <ul class="abilities">
            <li class="abilities__item"><h2 class="heading">Подберёт запчасти</h2></li>
            <li class="abilities__item"><h2 class="heading">Организует доставку запчастей</h2></li>
            <li class="abilities__item"><h2 class="heading">Посчитает стоимость ремонта</h2></li>
            <li class="abilities__item"><h2 class="heading">Запишет на ближайшее СТО</h2></li>
          </ul>
        </div>
        <p class="helper__text">...и решит другие вопросы, связанные с вашим авто.</p>

        <form
          class="helper__form"
          @submit.prevent="send">
          <div
            class="field-wrapper phone"
            :class="{invalid: validation.hasError('formData.phone')}">
            <HelperPhone
              v-model="formData.phone"
              placeholder="+7 (9_ _) _ _ _ - _ _ - _ _"
              autofocus="autofocus"
              class="fluid helper__input _phone"/>
            <div
              v-if="validation.hasError('formData.phone')"
              class="error mobilshow">
              {{ validation.firstError('formData.phone') }}
            </div>
          </div>

          <div class="field-wrapper">
            <button
              type="submit"
              @submit.prevent="send"
              :disabled="actionDisabled || loading"
              class="ui button yellow fluid">
              Жду звонка через 5 минут!
            </button>
          </div>
          <div
            v-if="validation.hasError('formData.phone')"
            class="error desktopshow">
            {{ validation.firstError('formData.phone') }}
          </div>

          <div class="so desktopshow">
            <a
              class="so__item"
              target="_blank"
              :href="`tg://resolve?domain=${$config.socials.telegram}`"
              rel="nofollow"
              @click="$ym('messanger_telegram')"
              v-tooltip="{ classes: popoverBaseClass, trigger: 'hover', placement: 'bottom', content: 'Telegram' }">
              <img
                svg-inline
                src="~/assets/svg/color-telegram.svg"
                alt="">
            </a>
            <a
              class="so__item"
              target="_blank"
              :href="`viber://chat?number=${$config.socials.viber}`"
              rel="nofollow"
              @click="$ym('messanger_viber')"
              v-tooltip="{ classes: popoverBaseClass, trigger: 'hover', placement: 'bottom', content: 'Viber' }">
              <img
                svg-inline
                src="~/assets/svg/color-viber.svg"
                alt="">
            </a>
            <a
              class="so__item"
              target="_blank"
              :href="`https://wa.me/${$config.socials.whatsapp}`"
              @click="$ym('messanger_whatsapp')"
              v-tooltip="{ classes: popoverBaseClass, trigger: 'hover', placement: 'bottom', content: 'Whatsapp' }">
              <img
                svg-inline
                src="~/assets/svg/color-whatsup.svg"
                alt="">
            </a>
          </div>

        </form>
      </div>

      <div
        v-else
        class="helper__filled">
        <img
          class="img"
          src="~assets/images/check-circular.svg"
          alt="">
        <div class="success">
          <h2 class="heading title">
            <p>Ваш запрос № {{ requestId }} отправлен!</p>
            <p>Мы свяжемся с вами в&nbsp;течение&nbsp;5&nbsp;минут!</p>
          </h2>
          <div class="end">
            <p>Приготовьте, пожалуйста, VIN номер автомобиля, если&nbsp;требуется
            подобрать&nbsp;запчасть.</p>
            <p>Спасибо за Ваше доверие!</p>
          </div>
        </div>
      </div>

      <div class="helper__promise">
        <div
          v-if="!complete"
          class="so mobilshow">
          <a
            class="so__item"
            @click="$ym('messanger_telegram')"
            rel="nofollow"
            :href="`tg://resolve?domain=${$config.socials.telegram}`">
            <img
              svg-inline
              src="~/assets/svg/color-telegram.svg"
              alt="">
          </a>
          <a
            class="so__item"
            @click="$ym('messanger_viber')"
            rel="nofollow"
            :href="`viber://chat?number=${$config.socials.viber}`">
            <img
              svg-inline
              src="~/assets/svg/color-viber.svg"
              alt="">
          </a>
          <a
            class="so__item"
            @click="$ym('messanger_whatsapp')"
            :href="`https://wa.me/${$config.socials.whatsapp}`">
            <img
              svg-inline
              src="~/assets/svg/color-whatsup.svg"
              alt="">
          </a>
        </div>
        <ul class="info">
          <li class="info__item phone">
            <a :href="`tel:${trimPhoneNumber($config.contacts.info.phone)}`">{{ $config.contacts.info.phone }}</a>
          </li>
          <li class="info__item clock">05:00 – 18:00 (по МСК)</li>
          <li class="info__item about">
            <flink
              href="/about-us/concierge"
              @click.native="$ym('recall_offer_click')"
              domain="main"
              target="_blank"
              class="aqualink helper__link">
              Договор об использовании сервиса
            </flink>
          </li>
        </ul>
      </div>
    </div>
  </div>
</template>

<script>
import Multiselect from 'vue-multiselect';
import { createNamespacedHelpers } from 'vuex';
import SimpleVueValidation from 'simple-vue-validator';

import { SHOW } from '~/assets/js/store/infoModal/action-types';
import Validator from '~/assets/js/validator';
import mapFilters from '~/assets/js/helpers/map-filters';

import HelperPhone from '~/components/redesign/helper/helper-phone';
import Breadcrumb from '~/components/redesign/app-breadcrumbs';

const STORE_INFO_MODAL = createNamespacedHelpers('infoModal');

export default {
  name: 'HelperIndexPage',
  components: {
    Breadcrumb,
    HelperPhone,
    Multiselect,
  },
  mixins: [SimpleVueValidation.mixin],
  data() {
    const formData = {
      phone: '',
    };
    return {
      popoverBaseClass: 'kit tooltip dark',
      loading: false,
      complete: false,
      formData,
      reasonOptions: [{
        id: 'PROBLEM_SEARCH_PARTS',
        name: 'Поиск запчасти',
      }, {
        id: 'PROBLEM_SEARCH_AUTOSERVICE',
        name: 'Поиск автосервиса',
      }, {
        id: 'PROBLEM_OTHER',
        name: 'Другая проблема',
      }],
      requestId: null,
      breadcrumbs: [
        {
          url: '',
          name: 'Вызвать консьержа',
        },
      ],
    };
  },
  computed: {
    actionDisabled() {
      return !Validator.checkPhone(this.formData.phone);
    },
  },
  validators: {},
  head() {
    return {
      link: [
        { hid: 'canonical', rel: 'canonical', href: `https://${this.$config.domains.helper}${this.$route.path}` },
      ],
    };
  },
  methods: {
    ...mapFilters(['trimPhoneNumber']),
    ...STORE_INFO_MODAL.mapActions({
      showInfo: SHOW,
    }),
    send() {
      this.$validate()
        .then((success) => {
          if (success) {
            this.loading = true;
            this.$axios.$post('/_main/conciergeRequest/create', {
              data: {
                phone: this.formData.phone,
              },
            }).then(({ data }) => {
              this.$ym('recall_form_submit');
              this.requestId = data.id;
              this.complete = true;
            }).catch((e) => {
              this.showError();
              console.log(e);
            }).finally(() => {
              this.loading = false;
            });
          }
        })
        .catch(e => console.log(e));
    },
    showError() {
      this.showInfo({
        text: 'Временная ошибка, пожалуйста, повторите запрос позднее',
        buttonVisible: false,
      });
    },
  },
};
</script>

<style scoped lang="scss">
    @import "~/assets/scss/modules/_helper-info.scss";

    .line.breadcrumb {
        display: flex;
        flex-flow: row nowrap;
        justify-content: space-between;
        align-items: stretch;
        flex: 0 1 auto;
        margin: 0;
        width: 100%;
        min-height: 1rem;
        padding-top: 1rem;
        background-color: transparent;

        .kit.breadcrumb {
            width: 100%!important;
            color: #fff;

            & > .divider {
                color: #fff!important;
            }
        }

        @media only screen and (max-width: 980px) {
            display: none !important;
        }
    }

    .helper {
        display: flex;
        flex-grow: 1;
        padding:  0 1rem 2.5rem;
        margin: 1.5rem 0;
        background: url('~assets/images/helper-1-mobile.jpg') center top/cover no-repeat;
        @media only screen and (min-width: 981px) {
            padding:  0 1.5rem 3.5rem;
            margin: 0;
            background: url('~assets/images/helper-1.jpg') center top/cover no-repeat;
        }

        &__container {
            display: flex;
            flex-flow: column nowrap;
            align-items: center;
            justify-content: flex-start;
            margin: 0 auto;
            width: 100%;
            @media only screen and (min-width: 981px) {
                max-width: 60.25rem;
            }
        }

        &__request {
            display: flex;
            flex-flow: column nowrap;
            align-items: flex-start;
            justify-content: flex-start;
            flex-grow: 1;
            position: relative;
        }

        & &__title {
            margin-top: 2.25rem;
            font-size: 1.625rem;
            line-height: 1.3;
            font-weight: 700;
            color: #FFCF68;
            @media only screen and (min-width: 981px) {
                margin: 3rem 0 1.875rem;
                font-size: 2.75rem;
            }
        }

        &__filled {
            display: flex;
            flex-flow: column nowrap;
            align-items: center;
            padding-top: 2.25rem;
            @media only screen and (min-width: 981px) {
                flex-flow: row nowrap;
                padding-top: 5.625rem;
            }

            .img {
                display: block;
                margin: 0 auto 1rem;
                @media only screen and (min-width: 981px) {
                    margin: 0.5rem 1.125rem auto 0;
                }
            }
            .success {
                display: block;
                text-align: center;
                @media only screen and (min-width: 981px) {
                    text-align: left;
                }
            }
            .title {
                display: block;
                color: #fff;
                font-size: 1.5rem;
                font-weight: 700;
                line-height: 1.3;
                p {
                    font: inherit;
                    color: inherit;
                    padding: 0 0 1rem 0;
                    margin: 0;
                }
                @media only screen and (min-width: 981px) {
                    font-size: 2.75rem;
                }
            }
            .end {
                display: block;
                color: #fff;
                font-size: 1.125rem;
                font-weight: 500;
                line-height: 1.3;
                p {
                    font: inherit;
                    color: inherit;
                    padding: 0 0 2rem 0;
                    margin: 0;
                }
                @media only screen and (min-width: 981px) {
                    font-size: 1.5rem;
                }
            }
        }

        &__text {
            margin: 0.75rem 0 0;
            font-size: 0.8125rem;
            font-weight: 500;
            color: #fff;
            @media only screen and (min-width: 981px) {
                font-size: 1rem;
            }
        }

        & &__subtitle {
            margin: 2.5rem 0 0;
            font: 500 1.3125rem Roboto, sans-serif;
            @media only screen and (min-width: 981px) {
                color: #fff;
            }
        }

        &__form {
            display: block;
            width: 100%;
            max-width: 23.75rem;
            margin-top: 2.375rem;

            @media only screen and (min-width: 981px) {
                display: flex;
                align-items: flex-start;
                flex-wrap: wrap;
                margin-top: 2.875rem;
                height: 4.625rem;
                //width: 740px;
                max-width: none;
            }
        }

        &__input {
            display: block;
            min-width: 16.875rem;
            width: 100%;
            margin: 0;
            .ui.input {
                width: 100%;
            }
            @media only screen and (min-width: 981px) {
                min-width: 0;
            }

            &._reason {
                @media only screen and (min-width: 981px) {
                    width: 12.75rem;
                }
            }
        }

        &__link {
            font: inherit;
            color: inherit;
            text-decoration: underline;
            @media only screen and (min-width: 981px) {
                font: inherit;
                color: inherit;
            }
        }

        &__end {
            font: 400 1.3125rem Roboto, sans-serif;
            color: #000;
            @media only screen and (min-width: 981px) {
                width: 24.375rem;
                color: #fff;
            }
        }
        &__promise {
            display: block;
            margin: auto auto 0 0;
        }

        & .ui.button.yellow.fluid {
            width: 100%;
            color: rgb(27, 28, 29);
            background-color: rgb(255, 207, 104);

            &[disabled] {
                opacity: .65!important;
            }
        }
    }

    .abilities {
        display: flex;
        flex-flow: column wrap;
        justify-content: flex-start;
        align-items: flex-start;
        padding: 0;
        margin: 0;
        list-style: none;
        color: #FFF;
        @media only screen and (min-width: 981px) {
            flex-flow: row wrap;
            align-items: center;

        }
        &__item {
            display: inline-flex;
            justify-content: flex-start;
            align-items: center;
            font-size: 1rem;
            line-height: 1.3;
            font-weight: 500;
            padding: 0.25rem 0 0.25rem 1.875rem;
            background: url('~assets/images/i-checked.png') left top/1.625rem no-repeat;
            @media only screen and (min-width: 981px) {
                width: 45%;
                padding: 0.625rem 0 0.625rem 2.375rem;
                font-size: 1.5rem;
                background-size: 2rem;
                white-space: nowrap;
                background-position: left center;
            }
            h2 {
                font: inherit;
            }
        }
    }

    .field-wrapper {
        height: 5rem;
        @media only screen and (min-width: 981px) {
            display: inline-flex;
            height: 2.5rem;
            margin-right: 1.25rem;
            width: 35%;
        }
        @media only screen and (max-width: 1024px) {
            height: 5rem;
        }
        &.invalid {
            position: relative;
        }
    }

    .error {
        display: flex;
        padding: 0.5rem 0 0 1rem;
        font: 400 0.75rem Roboto, sans-serif;
        color: #E13C3C;
    }

    .so {
        display: flex;

        @media only screen and (max-width: 980px) {
            margin-left: -0.625rem;
            padding-bottom: 1rem;

            &.mobilshow {
                display: block;
            }

            &.desktopshow {
                display: none;
            }
        }

        @media only screen and (min-width: 981px) {
            padding-left: 0.3125rem;

            &.mobilshow {
                display: none;
            }

            &.desktopshow {
                display: block;
            }
        }

        &__item {
            display: inline-flex;
            vertical-align: middle;
            height: 2.625rem;
            width: 2.625rem;
            margin: 0 0.625rem;
            svg {
                display: block;
                width: 100%;
                height: 100%;
                margin: auto;
            }
        }
    }
</style>
